package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLMultiVal_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLMultiVal extends JNIObject  {
	
	/* @generated */
	protected ISLMultiVal(long ptr) {
		/*** PROTECTED REGION ID(ISLMultiVal_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLMultiVal build(long ptr) {
		return new ISLMultiVal(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLMultiVal_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_multi_val_from_val_list 
	 * 
	@take space list
	 * @generated
	**/
	 public static ISLMultiVal buildFromValList(ISLSpace space, ISLValList list) { 
		/*** PROTECTED REGION ID(static_isl_multi_val_from_val_list) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(space, list);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_from_val_list(getNativePtr(space), getNativePtr(list)));
			} finally {
				taken(space);
				taken(list);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_zero 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLMultiVal buildZero(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_multi_val_zero) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_zero(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLMultiVal mv, int format) { 
		/*** PROTECTED REGION ID(static_isl_multi_val_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_val_to_string(getNativePtr(mv), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_multi_val_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_multi_val_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_multi_val_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_multi_val_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_multi_val_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_copy 
	 * 
	 * @generated
	**/
	public ISLMultiVal copy() {
		/*** PROTECTED REGION ID(isl_multi_val_copy) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_multi_val_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_multi_val_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_multi_val_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_val_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_get_val 
	 * 
	 * @generated
	**/
	public ISLVal getVal(int pos) {
		/*** PROTECTED REGION ID(isl_multi_val_get_val) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_multi_val_get_val(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_set_val 
	 * 
	 * @take this val
	 * @generated
	**/
	public ISLMultiVal setVal(int pos, ISLVal val) {
		/*** PROTECTED REGION ID(isl_multi_val_set_val) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this, val);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_set_val(getNativePtr(this), pos, getNativePtr(val)));
			} finally {
				taken(this);
				taken(val);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_set_dim_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiVal setDimName(ISLDimType type, int pos, String s) {
		/*** PROTECTED REGION ID(isl_multi_val_set_dim_name) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_set_dim_name(getNativePtr(this), type.getValue(), pos, s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_get_tuple_name 
	 * 
	 * @generated
	**/
	public String getTupleName(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_multi_val_get_tuple_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_val_get_tuple_name(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_set_tuple_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiVal setTupleName(ISLDimType type, String s) {
		/*** PROTECTED REGION ID(isl_multi_val_set_tuple_name) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_set_tuple_name(getNativePtr(this), type.getValue(), s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_has_tuple_id 
	 * 
	 * @generated
	**/
	public boolean hasTupleName(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_multi_val_has_tuple_id) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_val_has_tuple_id(getNativePtr(this), type.getValue()) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_range_is_wrapping 
	 * 
	 * @generated
	**/
	public boolean isWrapping() {
		/*** PROTECTED REGION ID(isl_multi_val_range_is_wrapping) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_val_range_is_wrapping(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_insert_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiVal insertDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_multi_val_insert_dims) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_insert_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_add_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiVal addDims(ISLDimType type, int n) {
		/*** PROTECTED REGION ID(isl_multi_val_add_dims) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_add_dims(getNativePtr(this), type.getValue(), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_drop_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiVal dropDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_multi_val_drop_dims) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_drop_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLMultiVal alignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_multi_val_align_params) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_from_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiVal fromRange() {
		/*** PROTECTED REGION ID(isl_multi_val_from_range) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_from_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_range_splice 
	 * 
	 * @take this mv2
	 * @generated
	**/
	public ISLMultiVal rangeSplice(int pos, ISLMultiVal mv2) {
		/*** PROTECTED REGION ID(isl_multi_val_range_splice) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this, mv2);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_range_splice(getNativePtr(this), pos, getNativePtr(mv2)));
			} finally {
				taken(this);
				taken(mv2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_range_product 
	 * 
	 * @take this mv2
	 * @generated
	**/
	public ISLMultiVal rangeProduct(ISLMultiVal mv2) {
		/*** PROTECTED REGION ID(isl_multi_val_range_product) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this, mv2);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_range_product(getNativePtr(this), getNativePtr(mv2)));
			} finally {
				taken(this);
				taken(mv2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_range_factor_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiVal rangeFactorDomain() {
		/*** PROTECTED REGION ID(isl_multi_val_range_factor_domain) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_range_factor_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_range_factor_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiVal rangeFactorRange() {
		/*** PROTECTED REGION ID(isl_multi_val_range_factor_range) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_range_factor_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_flat_range_product 
	 * 
	 * @take this mv2
	 * @generated
	**/
	public ISLMultiVal flatRangeProduct(ISLMultiVal mv2) {
		/*** PROTECTED REGION ID(isl_multi_val_flat_range_product) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this, mv2);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_flat_range_product(getNativePtr(this), getNativePtr(mv2)));
			} finally {
				taken(this);
				taken(mv2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_product 
	 * 
	 * @take this mv2
	 * @generated
	**/
	public ISLMultiVal product(ISLMultiVal mv2) {
		/*** PROTECTED REGION ID(isl_multi_val_product) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this, mv2);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_product(getNativePtr(this), getNativePtr(mv2)));
			} finally {
				taken(this);
				taken(mv2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_add_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLMultiVal add(ISLVal v) {
		/*** PROTECTED REGION ID(isl_multi_val_add_val) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_add_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_mod_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLMultiVal mod(ISLVal v) {
		/*** PROTECTED REGION ID(isl_multi_val_mod_val) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_mod_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_scale_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLMultiVal scale(ISLVal v) {
		/*** PROTECTED REGION ID(isl_multi_val_scale_val) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_scale_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_scale_multi_val 
	 * 
	 * @take this mv2
	 * @generated
	**/
	public ISLMultiVal scale(ISLMultiVal mv2) {
		/*** PROTECTED REGION ID(isl_multi_val_scale_multi_val) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this, mv2);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_scale_multi_val(getNativePtr(this), getNativePtr(mv2)));
			} finally {
				taken(this);
				taken(mv2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_val_scale_down_multi_val 
	 * 
	 * @take this mv2
	 * @generated
	**/
	public ISLMultiVal scaleDown(ISLMultiVal mv2) {
		/*** PROTECTED REGION ID(isl_multi_val_scale_down_multi_val) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this, mv2);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_val_scale_down_multi_val(getNativePtr(this), getNativePtr(mv2)));
			} finally {
				taken(this);
				taken(mv2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLMultiVal_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
